---
title: Get a given APM retention filter
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > APM Retention Filters
---

# Get a given APM retention filter{% #get-a-given-apm-retention-filter %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                                                      |
| ----------------- | --------------------------------------------------------------------------------- |
| ap1.datadoghq.com | GET https://api.ap1.datadoghq.com/api/v2/apm/config/retention-filters/{filter_id} |
| ap2.datadoghq.com | GET https://api.ap2.datadoghq.com/api/v2/apm/config/retention-filters/{filter_id} |
| app.datadoghq.eu  | GET https://api.datadoghq.eu/api/v2/apm/config/retention-filters/{filter_id}      |
| app.ddog-gov.com  | GET https://api.ddog-gov.com/api/v2/apm/config/retention-filters/{filter_id}      |
| us2.ddog-gov.com  | GET https://api.us2.ddog-gov.com/api/v2/apm/config/retention-filters/{filter_id}  |
| app.datadoghq.com | GET https://api.datadoghq.com/api/v2/apm/config/retention-filters/{filter_id}     |
| us3.datadoghq.com | GET https://api.us3.datadoghq.com/api/v2/apm/config/retention-filters/{filter_id} |
| us5.datadoghq.com | GET https://api.us5.datadoghq.com/api/v2/apm/config/retention-filters/{filter_id} |

### Overview

Get an APM retention filter. This endpoint requires the `apm_retention_filter_read` permission.

### Arguments

#### Path Parameters

| Name                        | Type   | Description                     |
| --------------------------- | ------ | ------------------------------- |
| filter_id [*required*] | string | The ID of the retention filter. |

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
The retention filters definition.

| Parent field | Field                        | Type    | Description                                                                                                                                         |
| ------------ | ---------------------------- | ------- | --------------------------------------------------------------------------------------------------------------------------------------------------- |
|              | data                         | object  | The definition of the retention filter.                                                                                                             |
| data         | attributes [*required*] | object  | The attributes of the retention filter.                                                                                                             |
| attributes   | created_at                   | int64   | The creation timestamp of the retention filter.                                                                                                     |
| attributes   | created_by                   | string  | The creator of the retention filter.                                                                                                                |
| attributes   | editable                     | boolean | Shows whether the filter can be edited.                                                                                                             |
| attributes   | enabled                      | boolean | The status of the retention filter (Enabled/Disabled).                                                                                              |
| attributes   | execution_order              | int64   | The execution order of the retention filter.                                                                                                        |
| attributes   | filter                       | object  | The spans filter used to index spans.                                                                                                               |
| filter       | query                        | string  | The search query - following the [span search syntax](https://docs.datadoghq.com/tracing/trace_explorer/query_syntax.md).                           |
| attributes   | filter_type                  | enum    | The type of retention filter. Allowed enum values: `spans-sampling-processor,spans-errors-sampling-processor,spans-appsec-sampling-processor`       |
| attributes   | modified_at                  | int64   | The modification timestamp of the retention filter.                                                                                                 |
| attributes   | modified_by                  | string  | The modifier of the retention filter.                                                                                                               |
| attributes   | name                         | string  | The name of the retention filter.                                                                                                                   |
| attributes   | rate                         | double  | Sample rate to apply to spans going through this retention filter. A value of 1.0 keeps all spans matching the query.                               |
| attributes   | trace_rate                   | double  | Sample rate to apply to traces containing spans going through this retention filter. A value of 1.0 keeps all traces with spans matching the query. |
| data         | id [*required*]         | string  | The ID of the retention filter.                                                                                                                     |
| data         | type [*required*]       | enum    | The type of the resource. Allowed enum values: `apm_retention_filter`                                                                               |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "created_at": "integer",
      "created_by": "string",
      "editable": true,
      "enabled": true,
      "execution_order": "integer",
      "filter": {
        "query": "@http.status_code:200 service:my-service"
      },
      "filter_type": "spans-sampling-processor",
      "modified_at": "integer",
      "modified_by": "string",
      "name": "my retention filter",
      "rate": 1,
      "trace_rate": 1
    },
    "id": "7RBOb7dLSYWI01yc3pIH8w",
    "type": "apm_retention_filter"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Not Authorized
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \# Path parameters export filter_id="CHANGE_ME" \# Curl command curl -X GET "https://api.datadoghq.com/api/v2/apm/config/retention-filters/${filter_id}" \
-H "Accept: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" 
                
##### 

```python
"""
Get a given APM retention filter returns "OK" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.apm_retention_filters_api import APMRetentionFiltersApi

# there is a valid "retention_filter" in the system
RETENTION_FILTER_DATA_ID = environ["RETENTION_FILTER_DATA_ID"]

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = APMRetentionFiltersApi(api_client)
    response = api_instance.get_apm_retention_filter(
        filter_id=RETENTION_FILTER_DATA_ID,
    )

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
##### 

```ruby
# Get a given APM retention filter returns "OK" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::APMRetentionFiltersAPI.new

# there is a valid "retention_filter" in the system
RETENTION_FILTER_DATA_ID = ENV["RETENTION_FILTER_DATA_ID"]
p api_instance.get_apm_retention_filter(RETENTION_FILTER_DATA_ID)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
##### 

```go
// Get a given APM retention filter returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	// there is a valid "retention_filter" in the system
	RetentionFilterDataID := os.Getenv("RETENTION_FILTER_DATA_ID")

	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewAPMRetentionFiltersApi(apiClient)
	resp, r, err := api.GetApmRetentionFilter(ctx, RetentionFilterDataID)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `APMRetentionFiltersApi.GetApmRetentionFilter`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `APMRetentionFiltersApi.GetApmRetentionFilter`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
##### 

```java
// Get a given APM retention filter returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.ApmRetentionFiltersApi;
import com.datadog.api.client.v2.model.RetentionFilterResponse;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    ApmRetentionFiltersApi apiInstance = new ApmRetentionFiltersApi(defaultClient);

    // there is a valid "retention_filter" in the system
    String RETENTION_FILTER_DATA_ID = System.getenv("RETENTION_FILTER_DATA_ID");

    try {
      RetentionFilterResponse result = apiInstance.getApmRetentionFilter(RETENTION_FILTER_DATA_ID);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ApmRetentionFiltersApi#getApmRetentionFilter");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
##### 

```rust
// Get a given APM retention filter returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_apm_retention_filters::APMRetentionFiltersAPI;

#[tokio::main]
async fn main() {
    // there is a valid "retention_filter" in the system
    let retention_filter_data_id = std::env::var("RETENTION_FILTER_DATA_ID").unwrap();
    let configuration = datadog::Configuration::new();
    let api = APMRetentionFiltersAPI::with_config(configuration);
    let resp = api
        .get_apm_retention_filter(retention_filter_data_id.clone())
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
##### 

```typescript
/**
 * Get a given APM retention filter returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.APMRetentionFiltersApi(configuration);

// there is a valid "retention_filter" in the system
const RETENTION_FILTER_DATA_ID = process.env.RETENTION_FILTER_DATA_ID as string;

const params: v2.APMRetentionFiltersApiGetApmRetentionFilterRequest = {
  filterId: RETENTION_FILTER_DATA_ID,
};

apiInstance
  .getApmRetentionFilter(params)
  .then((data: v2.RetentionFilterResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"
{% /tab %}
